# HG changeset patch
# User Guillaume Flandin <guillaume.offline@gmail.com>
# Date 1637822455 -32400
#      Thu Nov 25 15:40:55 2021 +0900
# Branch stable
# Node ID 642f0cc5783ac246bc64452131dd227c2c973316
# Parent  4f4fa00edadae0c3754e78b34a2a3344f0eefcfa
New function memoize to optimize repetitive function calls (bug #60860).

* scripts/miscellaneous/clearAllMemoizedCaches.m: new function.
* scripts/miscellaneous/memoize.m: new function.
* scripts/miscellaneous/private/__memoize__.m: new function.
* scripts/miscellaneous/module.mk: add new functions to build system.

* scripts/+matlab/+lang/MemoizedFunction.m: new function.
* scripts/+matlab/+lang/module.mk: add new functions to build system.

diff -r 4f4fa00edada -r 642f0cc5783a NEWS
--- a/NEWS	Thu Nov 25 14:18:37 2021 +0900
+++ b/NEWS	Thu Nov 25 15:40:55 2021 +0900
@@ -265,6 +265,7 @@ a scalar.
 
 ### Alphabetical list of new functions added in Octave 7
 
+* `clearAllMemoizedCaches`
 * `cospi`
 * `getpixelposition`
 * `endsWith`
@@ -273,8 +274,10 @@ a scalar.
 * `jsonencode`
 * `jupyter_notebook`
 * `listfonts`
+* `matlab.lang.MemoizedFunction`
 * `matlab.net.base64decode`
 * `matlab.net.base64encode`
+* `memoize`
 * `memory`
 * `ordqz`
 * `rng`
diff -r 4f4fa00edada -r 642f0cc5783a scripts/+matlab/+lang/MemoizedFunction.m
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/scripts/+matlab/+lang/MemoizedFunction.m	Thu Nov 25 15:40:55 2021 +0900
@@ -0,0 +1,203 @@
+########################################################################
+##
+## Copyright (C) 2021 The Octave Project Developers
+##
+## See the file COPYRIGHT.md in the top-level directory of this
+## distribution or <https://octave.org/copyright/>.
+##
+## This file is part of Octave.
+##
+## Octave is free software: you can redistribute it and/or modify it
+## under the terms of the GNU General Public License as published by
+## the Free Software Foundation, either version 3 of the License, or
+## (at your option) any later version.
+##
+## Octave is distributed in the hope that it will be useful, but
+## WITHOUT ANY WARRANTY; without even the implied warranty of
+## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+## GNU General Public License for more details.
+##
+## You should have received a copy of the GNU General Public License
+## along with Octave; see the file COPYING.  If not, see
+## <https://www.gnu.org/licenses/>.
+##
+########################################################################
+
+
+classdef MemoizedFunction < handle
+
+  properties (GetAccess = public, SetAccess = private)
+    Function = [];
+  endproperties
+
+  properties (Access = public)
+    Enabled = true;
+    CacheSize = 10;
+  endproperties
+
+  properties (Access = private, Hidden = true)
+    Cache;
+  endproperties
+
+  methods (Access = public)
+
+    function this = MemoizedFunction (fcn_handle)
+      if (! isa (fcn_handle, "function_handle"))
+        error (["matlab.lang.MemoizedFunction: FCN_HANDLE must be a ", ...
+                "function handle"]);
+      endif
+      this.Function = fcn_handle;
+      this.Cache = init_cache ();
+    endfunction
+
+    function varargout = subsref (this, s)
+      switch (s(1).type)
+        case "."
+          switch (s(1).subs)
+            case "Function"
+              varargout{1} = this.Function;
+            case "Enabled"
+              varargout{1} = this.Enabled;
+            case "CacheSize"
+              varargout{1} = this.CacheSize;
+            case "clearCache"
+              clearCache (this);
+              varargout = {};
+            case "stats"
+              varargout{1} = stats (this);
+            otherwise
+              error ("matlab.lang.MemoizedFunction: unknown property '%s'", ...
+                     s(1).subs);
+          endswitch
+        case "()"
+          n_out = ifelse (nargout == 0, 1, nargout);
+          if (! this.Enabled)
+            [varargout{1:n_out}] = feval (this.Function, s(1).subs{:});
+          else
+            cache_idx = [];
+            for i=1:numel (this.Cache.Inputs)
+              if (isequaln (this.Cache.Inputs{i}, s(1).subs) ...
+                  && isequal (this.Cache.Nargout(i), nargout))
+                cache_idx = i;
+                break;
+              endif
+            endfor
+            if (! isempty (cache_idx))
+              [varargout{1:n_out}] = deal (this.Cache.Outputs{cache_idx}{:});
+              this.Cache.TotalHits += 1;
+              this.Cache.HitCount(cache_idx) += 1;
+            else
+              [varargout{1:n_out}] = feval (this.Function, s(1).subs{:});
+              n = numel(this.Cache.Inputs) + 1;
+              if (n > this.CacheSize)
+                this.Cache.Inputs(1)   = [];
+                this.Cache.Nargout(1)  = [];
+                this.Cache.Outputs(1)  = [];
+                this.Cache.HitCount(1) = [];
+                n -= 1; # FIFO
+              endif
+              this.Cache.Inputs{n}   = s(1).subs;
+              this.Cache.Nargout(n)  = nargout;
+              this.Cache.Outputs{n}  = varargout;
+              this.Cache.HitCount(n) = 0;
+              this.Cache.TotalMisses += 1;
+            endif
+          endif
+        otherwise
+          error (["matlab.lang.MemoizedFunction: only '()' indexing is ", ...
+                  "supported"]);
+      endswitch
+      if (numel (s) > 1)
+        varargout{1} = subsref (varargout{1}, s(2:end));
+      endif
+    endfunction
+
+    function this = subsasgn (this, s, val)
+      if (numel (s) > 1)
+        error (["matlab.lang.MemoizedFunction: only one level of indexing ", ...
+                "is supported"]);
+      endif
+      switch (s(1).type)
+        case "."
+          switch (s(1).subs)
+            case "Function"
+              error (["matlab.lang.MemoizedFunction: property Function is ", ...
+                      "read-only"]);
+            case "Enabled"
+              if (! isscalar (val) || ! (isnumeric (val) || islogical (val)) ...
+                  || ! isfinite (val))
+                error (["matlab.lang.MemoizedFunction: Enabled must be a ", ...
+                        "logical scalar"]);
+              endif
+              this.Enabled = logical (val);
+            case "CacheSize"
+              if (! isscalar (val) || ! isnumeric (val) || ! isfinite (val) ...
+                  || ceil (val) != val || val < 1)
+                error (["matlab.lang.MemoizedFunction: CacheSize must ", ...
+                        "be a positive integer scalar"])
+              endif
+              this.CacheSize = double (val);
+              n = numel(this.Cache.Inputs) - this.CacheSize;
+              if (n > 0)
+                this.Cache.Inputs(1:n)   = [];
+                this.Cache.Nargout(1:n)  = [];
+                this.Cache.Outputs(1:n)  = [];
+                this.Cache.HitCount(1:n) = [];
+              endif
+            otherwise
+              error ("matlab.lang.MemoizedFunction: unknown property '%s'", ...
+                     s(1).subs);
+          endswitch
+        otherwise
+          error (["matlab.lang.MemoizedFunction: only '.' indexing is ", ...
+                  "supported for assigning values"]);
+      endswitch
+    endfunction
+
+    function clearCache (this)
+      if (nargin > 1 || nargout)
+        error ("matlab.lang.MemoizedFunction: Invalid call");
+      endif
+      this.Cache = init_cache ();
+    endfunction
+
+    function s = stats (this)
+      if (isempty (this.Cache.Inputs))
+        CacheHitRatePercent   = 0;
+        CacheOccupancyPercent = 0;
+        MostHitCachedInput    = [];
+      else
+        CacheHitRatePercent   = (this.Cache.TotalHits / ...
+          (this.Cache.TotalHits + this.Cache.TotalMisses)) * 100;
+        CacheOccupancyPercent = numel (this.Cache.Inputs) / this.CacheSize * 100;
+        [~, i] = max (this.Cache.HitCount);
+        MostHitCachedInput    = struct ("Hits", this.Cache.HitCount(i), ...
+                                        "Input", {this.Cache.Inputs{i}});
+      endif
+      s = struct (...
+      "Cache",                 this.Cache, ...
+      "MostHitCachedInput",    MostHitCachedInput, ...
+      "CacheHitRatePercent",   CacheHitRatePercent, ...
+      "CacheOccupancyPercent", CacheOccupancyPercent);
+    endfunction
+
+    function newobj = horzcat (varargin)
+      error ("matlab.lang.MemoizedFunction: concatenation is not allowed");
+    endfunction
+
+    function newobj = horzcat (varargin)
+      error ("matlab.lang.MemoizedFunction:  concatenation is not allowed");
+    endfunction
+
+  endmethods
+
+endclassdef
+
+function cache = init_cache ()
+cache = struct ("Inputs",      {{}}, ...
+                "Nargout",     [], ...
+                "Outputs",     {{}}, ...
+                "HitCount",    [], ...
+                "TotalHits",   0, ...
+                "TotalMisses", 0);
+endfunction
diff -r 4f4fa00edada -r 642f0cc5783a scripts/+matlab/+lang/module.mk
--- a/scripts/+matlab/+lang/module.mk	Thu Nov 25 14:18:37 2021 +0900
+++ b/scripts/+matlab/+lang/module.mk	Thu Nov 25 15:40:55 2021 +0900
@@ -2,7 +2,8 @@ FCN_FILE_DIRS += %reldir%
 
 %canon_reldir%_FCN_FILES = \
   %reldir%/makeUniqueStrings.m \
-  %reldir%/makeValidName.m
+  %reldir%/makeValidName.m \
+  %reldir%/MemoizedFunction.m
 
 %canon_reldir%dir = $(fcnfiledir)/+matlab/+lang
 
diff -r 4f4fa00edada -r 642f0cc5783a scripts/miscellaneous/clearAllMemoizedCaches.m
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/scripts/miscellaneous/clearAllMemoizedCaches.m	Thu Nov 25 15:40:55 2021 +0900
@@ -0,0 +1,44 @@
+########################################################################
+##
+## Copyright (C) 2021 The Octave Project Developers
+##
+## See the file COPYRIGHT.md in the top-level directory of this
+## distribution or <https://octave.org/copyright/>.
+##
+## This file is part of Octave.
+##
+## Octave is free software: you can redistribute it and/or modify it
+## under the terms of the GNU General Public License as published by
+## the Free Software Foundation, either version 3 of the License, or
+## (at your option) any later version.
+##
+## Octave is distributed in the hope that it will be useful, but
+## WITHOUT ANY WARRANTY; without even the implied warranty of
+## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+## GNU General Public License for more details.
+##
+## You should have received a copy of the GNU General Public License
+## along with Octave; see the file COPYING.  If not, see
+## <https://www.gnu.org/licenses/>.
+##
+########################################################################
+
+## -*- texinfo -*-
+## @deftypefn  {} {} clearAllMemoizedCaches ()
+## Clear all memoized caches.
+##
+## @seealso{memoize}
+## @end deftypefn
+
+function clearAllMemoizedCaches
+
+   if (nargin || nargout)
+    print_usage ();
+  endif
+
+  __memoize__ ();
+
+endfunction
+
+## Mark file as being tested.  No real test needed for this function.
+%!assert (1)
diff -r 4f4fa00edada -r 642f0cc5783a scripts/miscellaneous/memoize.m
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/scripts/miscellaneous/memoize.m	Thu Nov 25 15:40:55 2021 +0900
@@ -0,0 +1,73 @@
+########################################################################
+##
+## Copyright (C) 2021 The Octave Project Developers
+##
+## See the file COPYRIGHT.md in the top-level directory of this
+## distribution or <https://octave.org/copyright/>.
+##
+## This file is part of Octave.
+##
+## Octave is free software: you can redistribute it and/or modify it
+## under the terms of the GNU General Public License as published by
+## the Free Software Foundation, either version 3 of the License, or
+## (at your option) any later version.
+##
+## Octave is distributed in the hope that it will be useful, but
+## WITHOUT ANY WARRANTY; without even the implied warranty of
+## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+## GNU General Public License for more details.
+##
+## You should have received a copy of the GNU General Public License
+## along with Octave; see the file COPYING.  If not, see
+## <https://www.gnu.org/licenses/>.
+##
+########################################################################
+
+## -*- texinfo -*-
+## @deftypefn  {} {@var{mem_fcn_handle} =} memoize (@var{fcn_handle})
+##
+## @seealso{clearAllMemoizedCaches}
+## @end deftypefn
+
+function mem_fcn_handle = memoize (fcn_handle)
+
+  if (nargin != 1 || nargout > 1)
+    print_usage ();
+  endif
+  if (! isa (fcn_handle, "function_handle"))
+    error ("memoize: FCN_HANDLE must be a function handle");
+  endif
+
+  mem_fcn_handle = __memoize__ (fcn_handle);
+
+endfunction
+
+%!test
+%! fcn1 = memoize (@sin);
+%! assert (isa (fcn1, "matlab.lang.MemoizedFunction"));
+%! fcn1 (pi);
+%! fcn2 = memoize (@sin);
+%! fcn2 (2*pi);
+%! assert (isequal (fcn1, fcn2))
+
+%!test
+%! fcn = memoize (@rand);
+%! a = fcn ();
+%! b = fcn ();
+%! assert (a, b);
+%! fcn2 = memoize (@rand);
+%! c = fcn2 ();
+%! assert (a, c);
+
+%!test
+%! fcn = memoize (@plus);
+%! fcn.stats;
+%! stats (fcn);
+%! clearCache (fcn);
+%! fcn.clearCache;
+
+# Test input validation
+%!error memoize ();
+%!error memoize (1, 2);
+%!error [a, b] = memoize (1);
+%!error memoize (1);
diff -r 4f4fa00edada -r 642f0cc5783a scripts/miscellaneous/module.mk
--- a/scripts/miscellaneous/module.mk	Thu Nov 25 14:18:37 2021 +0900
+++ b/scripts/miscellaneous/module.mk	Thu Nov 25 15:40:55 2021 +0900
@@ -3,6 +3,7 @@ FCN_FILE_DIRS += \
   %reldir%/private
 
 %canon_reldir%_PRIVATE_FCN_FILES = \
+  %reldir%/private/__memoize__.m \
   %reldir%/private/__publish_html_output__.m \
   %reldir%/private/__publish_latex_output__.m \
   %reldir%/private/__w2mpth__.m \
@@ -15,6 +16,7 @@ FCN_FILE_DIRS += \
   %reldir%/bunzip2.m \
   %reldir%/cast.m \
   %reldir%/citation.m \
+  %reldir%/clearAllMemoizedCaches.m \
   %reldir%/clearvars.m \
   %reldir%/compare_versions.m \
   %reldir%/computer.m \
@@ -46,6 +48,7 @@ FCN_FILE_DIRS += \
   %reldir%/loadobj.m \
   %reldir%/ls.m \
   %reldir%/ls_command.m \
+  %reldir%/memoize.m \
   %reldir%/memory.m \
   %reldir%/menu.m \
   %reldir%/methods.m \
diff -r 4f4fa00edada -r 642f0cc5783a scripts/miscellaneous/private/__memoize__.m
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/scripts/miscellaneous/private/__memoize__.m	Thu Nov 25 15:40:55 2021 +0900
@@ -0,0 +1,57 @@
+########################################################################
+##
+## Copyright (C) 2021 The Octave Project Developers
+##
+## See the file COPYRIGHT.md in the top-level directory of this
+## distribution or <https://octave.org/copyright/>.
+##
+## This file is part of Octave.
+##
+## Octave is free software: you can redistribute it and/or modify it
+## under the terms of the GNU General Public License as published by
+## the Free Software Foundation, either version 3 of the License, or
+## (at your option) any later version.
+##
+## Octave is distributed in the hope that it will be useful, but
+## WITHOUT ANY WARRANTY; without even the implied warranty of
+## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+## GNU General Public License for more details.
+##
+## You should have received a copy of the GNU General Public License
+## along with Octave; see the file COPYING.  If not, see
+## <https://www.gnu.org/licenses/>.
+##
+########################################################################
+
+## -*- texinfo -*-
+## @deftypefn  {} {@var{mem_fcn_handle} =} __memoize__ (@var{fcn_handle})
+## @deftypefn  {} {} __memoize__ ()
+## Internal function used by memoize.
+##
+## @seealso{clearAllMemoizedCaches, memoize}
+## @end deftypefn
+
+function mem_fcn_handle = __memoize__ (fcn_handle)
+  persistent cached_mem_fcn_handle
+
+  if (nargin)
+
+    for i=1:numel (cached_mem_fcn_handle)
+      if (isequal (cached_mem_fcn_handle{i}.Function, fcn_handle))
+        mem_fcn_handle = cached_mem_fcn_handle{i};
+        return;
+      endif
+    endfor
+
+    mem_fcn_handle = matlab.lang.MemoizedFunction (fcn_handle);
+    cached_mem_fcn_handle{end+1} = mem_fcn_handle;
+
+  else
+
+    for i=1:numel (cached_mem_fcn_handle)
+      clearCache (cached_mem_fcn_handle{i});
+    endfor
+
+  endif
+
+endfunction